
export const LOG = msg => console.log('### monitor-brightness-volume@ailin.nemui ### ' + msg)

export const castInt = num => ~~num

export const isEmpty = obj => {
  for (const x in obj)
    return false
  return true
}

export const avg = arr => arr.reduce((a, b) => a + b) / arr.length

let activeTimeouts = {}
export const setTimeoutTracked = (ref, delay, ...params) => {
  let timeoutId
  timeoutId = setTimeout((...params) => {
    delete activeTimeouts[timeoutId]
    ref(...params)
  }, delay, ...params)
  activeTimeouts[timeoutId] = 1
}

export const clearAllTimeouts = () => {
  for (const timeoutId of Object.keys(activeTimeouts))
    clearTimeout(timeoutId)
  activeTimeouts = {}
}

export const sleep = ms => new Promise(resolve => setTimeoutTracked(resolve, ms))
